;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*     Assembler-Quelltext   Einchipmikrorechner Grundprogramme            *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
        

        .org 000h               ;Resetvektor
        jmp Init                ;Aufruf Initialisierungsprogramm
        
        .org 003H               ;Interuptvektor Externer Interupt
        disi
        jmp Int                 ;Aufruf Interuptroutine
        
        .org 007H               ;Interuptvektor Timerinterupt
        jmp TimeInt             ;Aufruf Timerinteruptroutine

        .org 00Ah               ;Beginn Anwenderprogramm

;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                  Beginn   Anwenderprogramm   (00A-3FF Hex)              *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                  Assembler-Quelltext   Einchipmikrorechner              *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

;Eingabe Uhrzeit und Starten Timer mit letzter Ziffer

Beginn  stop tcnt               ;Timer stoppen whrend Zeiteingabe
        call Eingabe            ;Eingabe Uhrzeit
        call TIReset            ;Timer reset
        call Anzein             ;Anzeige erlauben und anzeigen             
        
;Druckertestprogramm jeweils auf Tastendruck neu
;Durch Druck von 'Start'  -> Neustart Programm

Beginn1 call    Newline         ;Leerzeile Drucker
        
        mov     r1,#30h         ;Text in Druckerbuffer schreiben
        mov     r0,#Text
b1      mov     a,r0
        movp    a,@a
        mov     @r1,a
        inc     r1
        inc     r0
        mov     a,r1
        xrl     a,#40h
        jnz     b1
        call    Druck           ;Aufruf Druckertreiber
        
        mov     r1,#30h         ;Text in Druckerbuffer schreiben
        mov     r0,#Text1
b2      mov     a,r0
        movp    a,@a
        mov     @r1,a
        inc     r1
        inc     r0
        mov     a,r1
        xrl     a,#40h
        jnz     b2
        
        call    Druck           ;Aufruf Druckertreiber
        
        call    Newline         ;Leerzeile Drucker

        call    Taste
        xrl     a,#0eh          ;Test 'Start' ?
        jnz     Beginn1         ;Neustart Anwenderprogramm
        jmp     Init            ;Beim Bettigen von 'START' Neustart   
        
Text    .byte   '>'           
        .byte   ''
        .byte   'D'
        .byte   'r'
        .byte   'u'
        .byte   'c'
        .byte   'k'
        .byte   'e'
        .byte   'r'
        .byte   't'
        .byte   'e'
        .byte   's'
        .byte   't'
        .byte   ''
        .byte   '<'
        .byte   ''

Text1   .byte   '0'
        .byte   '1'
        .byte   '2'
        .byte   '3'
        .byte   '4'
        .byte   '5'
        .byte   '6'
        .byte   '7'
        .byte   '8'
        .byte   '9'
        .byte   '%'
        .byte   '&'
        .byte   '*'
        .byte   '+'
        .byte   ','
        .byte   '-'


;============================================================================
;----------------------------------------------------------------------------
;Ende Anwenderprogramm  >00AH-3FFH<
;----------------------------------------------------------------------------
;Initialisierungsprogramm (004H-4FFH)
        
        .org 400h

Init    call    LoeAnz          ;Anzeigenspeicher lschen    
        call    Anzeige         ;Ausgabe Anzeigenspeicher
        
        mov     a,#7fh          ;Motor OFF,Led ON
        outl    p2,a            ;Grundstellung PIO2    

        mov     a,#0fh          ;Nadeln aus, Tastaturmaske setzen   
        outl    p1,a            ;Grundstellung PIO1
        
        call TIReset            ;Timer-Reset
        call Anzein             ;Interupt-Anzeige Uhrzeit erlauben    
        
        en tcnti                ;Interupt Zeitgeber erlauben    

                                    
                                ;Hier knnen weitere Initbefehle            
                                ;eingesetzt werden
        
        jmp     Beginn
;---------------------------------------------------------------------------
;Interuptserviceroutine Externe Interuptanforderung

        .org 480H
Int     eni
        retr
;---------------------------------------------------------------------------
;Interuptserviceroutine Timer-Interupt          R0,(R1),R3,(R5,R6,R7)  (RB1)

        .org 4a0H

Wert    .equ 06h                ;Zhlwert Timer (06 = 20 ms) Zhlt hoch
Wertx   .equ 19h                ;1/2 sek fr Punkt aus
Wert1   .equ 32h                ;1. Timer-Zhler  (1 Sek) Zhlt bis zum Wert
Wert2   .equ 3ch                ;2. Timer-Zhler  (60 Sek) Zhlt bis zum Wert

TimeInt strt t                  ;Knstliche Verzgerung zur Zeitkorrektur
        dis tcnti               ;Verbiete Timerinterupt
        sel rb1                 ;Register-Bank wechseln
        mov r3,a                ;Akku retten        
        mov a,#Wert             ;Timer-Laden
        mov t,a
        mov r0,#29h        
        inc @r0                 ;Erhhen 1.Timer-Zhler
        mov a,@r0
        xrl a,#Wertx        
        jnz TI0
        anl p2,#f7h             ;Blink-Led aus
TI0     mov a,@r0
        xrl a,#Wert1
        jnz TI2               
        orl p2,#08h             ;Blink-Led an
        mov @r0,#0
        inc r0        
        inc @r0                 ;Erhhen 2.Timer-Zhler (Sekunden)
        mov a,@r0
        xrl a,#Wert2
        jnz TI2
        mov @r0,#0
        call Uhr                ;Nchste Minute, Uhrenzhler aufrufen
        mov r0,#24h             ;Test, ob Anzeige erlaubt ist
        mov a,@r0
        jz TI1                  ;Anzeige nicht erlaubt
        call Anzeige
TI1     orl p2,#08h             ;Blink-Led an
TI2     mov a,r3
        sel rb0
        en tcnti                ;Erlaube Timerinterupt
        retr
        
TIReset mov r0,#29h             ;Timer-Register und Zhlregister lschen/laden
        mov @r0,#0              ;und Timer starten
        inc r0
        mov @r0,#0
        mov a,#06h         
        mov t,a
        strt t
        ret

Anzaus  mov r1,#24h             ;Anzeige whrend Timer-Interupt verbieten
        mov @r1,#0
        ret

Anzein  mov r1,#24h             ;Anzeige whrend Timer-Interupt erlauben
        mov @r1,#01h
        call Anzeige
        ret
;---------------------------------------------------------------------------
;Zeicherdecoder Nadeldrucker
        
        .org 500h
        
ZS      .byte 36h       ;&
        .byte 49h
        .byte 56h
        .byte 20h
        .byte 50h

        .byte 7ch       ;A
        .byte 12h
        .byte 11h
        .byte 12h
        .byte 7ch

        .byte 7fh       ;B
        .byte 49h
        .byte 49h
        .byte 49h
        .byte 36h

        .byte 3eh       ;C
        .byte 41h
        .byte 41h
        .byte 41h
        .byte 22h

        .byte 7fh       ;D
        .byte 41h
        .byte 41h
        .byte 22h
        .byte 1ch

        .byte 7fh       ;E
        .byte 49h
        .byte 49h
        .byte 49h
        .byte 41h

        .byte 7fh       ;F
        .byte 09h
        .byte 09h
        .byte 09h
        .byte 01h

        .byte 3eh       ;G
        .byte 41h
        .byte 41h
        .byte 49h
        .byte 39h
                
        .byte 7fh       ;H
        .byte 08h
        .byte 08h
        .byte 08h
        .byte 7fh

        .byte 00h       ;I
        .byte 41h
        .byte 7fh
        .byte 41h
        .byte 00h

        .byte 20h       ;J
        .byte 40h
        .byte 41h
        .byte 3fh
        .byte 01h

        .byte 7fh       ;K
        .byte 08h
        .byte 14h
        .byte 22h
        .byte 41h

        .byte 7fh       ;L
        .byte 40h
        .byte 40h
        .byte 40h
        .byte 40h

        .byte 7fh       ;M
        .byte 02h
        .byte 0ch
        .byte 02h
        .byte 7fh

        .byte 7fh       ;N
        .byte 06h
        .byte 08h
        .byte 30h
        .byte 7fh

        .byte 3eh       ;O
        .byte 41h
        .byte 41h
        .byte 41h
        .byte 3eh
        
        .byte 7fh       ;P
        .byte 09h
        .byte 09h
        .byte 09h             
        .byte 06h

        .byte 3eh       ;Q
        .byte 41h
        .byte 51h
        .byte 21h
        .byte 5eh

        .byte 7fh       ;R
        .byte 09h
        .byte 19h
        .byte 29h
        .byte 46h

        .byte 46h       ;S
        .byte 49h
        .byte 49h
        .byte 49h
        .byte 31h

        .byte 01h       ;T
        .byte 01h
        .byte 7fh
        .byte 01h
        .byte 01h

        .byte 3fh       ;U
        .byte 40h
        .byte 40h
        .byte 40h
        .byte 3fh
                
        .byte 07h       ;V
        .byte 18h
        .byte 60h
        .byte 18h
        .byte 07h

        .byte 7fh       ;W
        .byte 20h
        .byte 18h
        .byte 20h
        .byte 7fh

        .byte 63h       ;X
        .byte 14h
        .byte 08h
        .byte 14h
        .byte 63h

        .byte 07h       ;Y
        .byte 08h
        .byte 70h
        .byte 08h
        .byte 07h

        .byte 61h       ;Z
        .byte 51h
        .byte 49h
        .byte 45h
        .byte 43h

        .byte 3eh       ;0
        .byte 51h
        .byte 49h
        .byte 45h
        .byte 3eh

        .byte 04h       ;1
        .byte 42h
        .byte 7fh
        .byte 40h
        .byte 00h

        .byte 42h       ;2
        .byte 61h
        .byte 51h
        .byte 49h
        .byte 46h

        .byte 21h       ;3
        .byte 41h
        .byte 49h
        .byte 4dh
        .byte 33h

        .byte 18h       ;4
        .byte 14h
        .byte 12h
        .byte 7fh
        .byte 10h

        .byte 27h       ;5
        .byte 45h
        .byte 45h
        .byte 45h
        .byte 39h

        .byte 3ch       ;6
        .byte 4ah
        .byte 49h
        .byte 49h
        .byte 31h

        .byte 71h       ;7
        .byte 09h
        .byte 05h
        .byte 03h
        .byte 01h

        .byte 36h       ;8
        .byte 49h
        .byte 49h
        .byte 49h
        .byte 36h

        .byte 46h       ;9
        .byte 49h
        .byte 49h
        .byte 49h
        .byte 3eh

        .byte 00h       ;
        .byte 00h
        .byte 60h
        .byte 60h
        .byte 00h

        .byte 00h       ;
        .byte 00h
        .byte 40h
        .byte 30h
        .byte 00h

        .byte 08h       ;-
        .byte 08h
        .byte 08h
        .byte 08h
        .byte 08h

        .byte 08h       ;+
        .byte 08h
        .byte 3eh
        .byte 08h
        .byte 08h

        .byte 00h       ;:
        .byte 00h
        .byte 66h
        .byte 66h
        .byte 00h

        .byte 14h       ;=
        .byte 14h
        .byte 14h
        .byte 14h
        .byte 14h

        .byte 60h       ;/
        .byte 10h
        .byte 08h
        .byte 04h
        .byte 03h

        .byte 00h       ;<
        .byte 08h
        .byte 14h
        .byte 22h
        .byte 00h

        .byte 00h       ;>
        .byte 22h
        .byte 14h
        .byte 08h
        .byte 00h

        .byte 63h       ;%
        .byte 13h
        .byte 08h
        .byte 64h
        .byte 63h

        .byte 02h       ;?
        .byte 01h
        .byte 59h
        .byte 09h
        .byte 06h

        .byte 14h       ;*
        .byte 08h
        .byte 3eh
        .byte 08h
        .byte 14h

        .byte 00h       ;Space
        .byte 00h
        .byte 00h
        .byte 00h
        .byte 00h
;----------------------------------------------------------------------------      
        .org 5feh               ;Adresse fr Listingdruck
ZSAdr   movp a,@a
        ret
;----------------------------------------------------------------------------
;Druckerroutine fr Ausdruck 1 Zeile

        .org 600h

Druck   call Konvert            ;Druckzeile konvertieren
        call Anzaus
        mov a,#00h
        outl p1,a
Druck1  mov a,#3fh
        outl p2,a
        in a,p2
        cpl a
        jb4 Druck1
        mov r1,#04h             ;Zeitschleife 10 ms laden
        call Zeit
        mov r6,#01h
Druck2  mov a,#3fh
        outl p2,a
        in a,p2
        jb4 Druck2
        mov r7,#00h
Druck3  call Laden
        mov r5,#00h
Druck4  mov a,#3fh
        outl p2,a
        in a,p2
        jb5 Druck4
        call Umsatz
Druck5  mov a,#3fh
        outl p2,a
        in a,p2
        cpl a
        jb5 Druck5
        inc r5
        mov a,r5
        xrl a,#06h
        jnz Druck4
        mov a,#00h
        outl p1,a
        inc r7
        mov a,r7
        xrl a,#04h
        jnz Druck3
        inc r6
        mov a,r6
        xrl a,#08h
        jnz Druck2
Druck6  mov a,#3fh
        outl p2,a
        in a,p2
        jb4 Druck6
        mov a,#7fh
        outl p2,a
        call Anzein
        ret
;----------------------------------------------------------------------------
;Unterprogramm Druckzeile konvertieren

Konvert mov r2,#10h
        mov r1,#30h
Kon1    mov a,@r1
        anl a,#7fh
        jb6 Kon2
        anl a,#1fh
        jmp Kon3
Kon2    anl a,#1fh
        orl a,#20h        
Kon3    add a,#Dec
        movp a,@a
        mov @r1,a
        inc r1
        djnz r2,Kon1
        ret
;----------------------------------------------------------------------------
;New Line fr Drucker

Newline call LoeBuf            ;Druckerbuffer lschen
        call Druck              ;Leeren Druckerbuffer ausgeben
        mov a,#0fh              ;Nadeln vom Drucker ausschalten
        outl p1,a               ;und Tastaturmaske setzen
        mov a,#40h              ;Punkt aus, Motor aus
        outl p2,a               ;Grundstellung PIO 2
        ret
;----------------------------------------------------------------------------
;Druckerbuffer lschen          A,R1,R2

LoeBuf  mov r1,#30h
        mov r2,#10h
        mov a,#20h
LoeBuf1 mov @r1,a
        inc r1
        djnz r2,LoeBuf1
        ret
;----------------------------------------------------------------------------
;Unterprogramm Hilfsregister laden

Laden   mov r0,#25h
        mov a,#30h
        add a,r7
        mov r1,a
Laden1  mov a,@r1
        mov @r0,a
        inc r0
        inc r1
        inc r1
        inc r1
        inc r1
        mov a,r0
        xrl a,#29h
        jnz Laden1
        ret
;----------------------------------------------------------------------------
;Umsetzen ZS auf Port -> Nadeln

Umsatz  mov r0,#00h
        mov r1,#25h
Umsatz1 mov a,r1
        add a,#dfh
        mov r2,a
        mov a,r6
        mov r4,a
        mov a,@r1
        add a,r5
        call ZSAdr
Umsatz2 djnz r4,Umsatz3
        jmp Umsatz4
Umsatz3 rra
        jmp Umsatz2
Umsatz4 anl a,#01h
Umsatz5 rla
        djnz r2, Umsatz5
        orl a,r0
        mov r0,a
        inc r1
        mov a,r1
        xrla,#29h
        jnz Umsatz1
        mov a,r0
        anl a,#f0h
        outl p1,a
        ret
;----------------------------------------------------------------------------
;Zeicherdecoder  Umsatz  ASCII -> Startadresse Zeichencodes

        .org 6c0h

Dec     .byte f5h       ;00
        .byte f5h
        .byte f5h
        .byte f5h
        .byte f5h
        .byte e6h
        .byte 00h
        .byte f5h
        .byte f5h
        .byte f5h
        .byte f0h
        .byte c8h
        .byte beh
        .byte c3h
        .byte b9h
        .byte d7h
        .byte 87h       ;10
        .byte 8ch
        .byte 91h
        .byte 96h
        .byte 9bh
        .byte a0h
        .byte a5h
        .byte aah
        .byte afh
        .byte b4h
        .byte cdh
        .byte f5h
        .byte dch
        .byte d2h
        .byte e1h
        .byte ebh
        .byte f5h        ;20
        .byte 05h
        .byte 0ah
        .byte 0fh
        .byte 14h
        .byte 19h
        .byte 1eh
        .byte 23h
        .byte 28h
        .byte 2dh
        .byte 32h
        .byte 37h
        .byte 3ch
        .byte 41h
        .byte 46h
        .byte 4bh
        .byte 50h        ;30
        .byte 55h
        .byte 5ah
        .byte 5fh
        .byte 64h
        .byte 69h
        .byte 6eh
        .byte 73h
        .byte 78h
        .byte 7dh
        .byte 82h
        .byte f5h
        .byte f5h
        .byte f5h
        .byte f5h
        .byte f5h
;----------------------------------------------------------------------------
;Zeichenausgabe 4-Stellig seriell       A,R5,R6,R7

        .org 700h

Anzeige mov a,r1                ;Reg 1 retten
        mov r5,a
        mov r1,#20h             ;Anfangsadresse Zeichenspeicher
An1     mov a,@r1               ;Zeichen holen
        mov r6,#04h             ;Zu verschiebende Byte pro Zeichen
        rra                     ;Verschieben
        mov r7,a                ;Zeichen retten
An2     mov a,r7                ;Zeichen holen
        rra                     ;Verschieben
        mov r7,a                ;Zeichen retten
        anl a,#40h              ;Bit ausgeben
        outl p2,a
        orl a,#80h
        outl p2,a
        anl a,#40h
        outl p2,a
        djnz r6,An2             ;4 * Verschoben ?
        inc r1                  ;Nchstes Zeichen
        mov a,r1
        xrl a,#24h
        jnz An1                 ;Fertig ?
        mov a,r5                ;Reg 1 wiederherstellen
        mov r1,a
        mov a,#40h              ;Punkt aus, Motor aus
        outl p2,a
        ret
;----------------------------------------------------------------------------
;Unterprogramm Zeitschleife 500ms       R1,R2

Zeit500 mov r1,#c4h
Zeit    mov r2,#feh             ;Einsprung fr Zeitschleife  R1 * 2,5 ms
Zeit1   nop
        nop
        djnz r2,Zeit1
        djnz r1,Zeit
        ret
;----------------------------------------------------------------------------
;Unterprogramm Anzeigenspeicher lschen         A,R1,R7

LoeAnz  mov r1,#20h
        mov r7,#04h
LoeAnz1 mov @r1,#00h
        inc r1
        djnz r7,LoeAnz1
        ret
;----------------------------------------------------------------------------
;Dezimalzhler 4-Stellig

Zaehler mov r1,#20h
Zaehl1  inc @r1
        mov a,@r1
        xrl a,#0ah
        jnz Zaehl2
        mov @r1,#00h
        inc r1
        mov a,r1
        jb4 Zaehl2
        jmp Zaehl1
Zaehl2  ret
;----------------------------------------------------------------------------
;Minuten-Stunden-Zhler bis 23:59       A,R1

Uhr     mov r1,#20h             
        inc @r1                 ;Minuten Einer +1
        mov a,#0ah
        xrl a,@r1
        jnz Uhr1                ;Minuten Einer >9 ?
        mov @r1,#00h            ;Minuten Einer=0
        inc r1
        inc @r1                 ;Minuten Zehner +1
        mov a,#06h
        xrl a,@r1               
        jnz Uhr1                ;Minuten Zehner >5 ?
        mov @r1,#00h            ;Minuten Zehner=0
        inc r1
        inc @r1                 ;Stunden Einer +1
        mov a,#04h              
        xrl a,@r1
        jz Uhr2
        mov a,#0ah
        xrl a,@r1
        jnz Uhr1
        mov @r1,#00h
        inc r1
        inc @r1                 ;Stunden Zehner+ 1
Uhr1    ret
Uhr2    inc r1
        mov a,#02h
        xrl a,@r1
        jnz Uhr1
        mov @r1,#00h
        dec r1
        mov @r1,#00h
        ret
;----------------------------------------------------------------------------
;60-Sekunden-Timer (fr 6 MHz-Quarz)    A,R5,(R1,R2)

Timer   mov r5,#3ch             ;Zhler 60 Sekunden
Timer1  mov a,#48h              ;Blinkender Punkt an
        outl p2,a
        call Zeit500               ;500 ms
        mov a,#40h              ;Blinkender Punkt aus
        outl p2,a
        call Zeit500               ;500 ms
        djnz r5,Timer1          ;60 sek vorbei ?
        ret
;----------------------------------------------------------------------------
;Tastatureingabe 4-Stellig mit Anzeige          A,R1,R7,(R5,R6)
        
Eingabe mov r1,#20h             ;Anzeigenspeicher mit "-" fllen
        mov r7,#04h
Ein1    mov @r1,#0ah
        inc r1
        djnz r7,Ein1
        call Anzeige            ;Anzeige 
        mov r1,#23h             ;Position im Speicher
Ein2    call Taste              ;Tastatureingabe
        mov @r1,a               ;Wert schreiben
        call Anzeige            ;Anzeige
        dec r1                  ;Nchste Stelle
        mov a,r1
        xrl a,#1fh              ;Letzte Stelle erreicht ?
        jnz Ein2                ;Letzte Stelle noch nicht erreicht !
        ret
;---------------------------------------------------------------------------
;Tastaturabfrage mit Entprelleung       A,R7            Tastencode in Akku
        
Taste   mov     a,#0fh          ;Maske setzen
        outl    p1,a            ;Ausgeben
        in      a,p1            ;Einlesen
        anl     a,#0fh          ;Maskieren
        xrl     a,#0fh
        jnz     Taste           ;Taste noch gedrckt ?
        mov r7,#ffh             ;Entprellung
Taste1  djnz r7,Taste1
Taste2  in      a,p1
        anl     a,#0fh
        xrl     a,#0fh
        jz      Taste2          ;Keine Taste gedrckt ?
        mov r7,#ffh             ;Entprellung
Taste3  djnz r7,Taste3
        xrl     a,#0fh          ;Wert wieder negieren
        ret
;----------------------------------------------------------------------------
        .org 7feh               ;Adresse fr Listingdruck
Adr7    movp a,@a
        ret
;----------------------------------------------------------------------------
.End
;----------------------------------------------------------------------------

